	/*
	
	Replication package
	Table 1. Descriptive Vital Statistics Registers main sample 2013-2016
	
	*/

    
clear 		all 
set 		more off

cap log close
log using "Logs/Table 1.smcl", replace
	

********************************************************************************

	use 	"Data\base_hospital_cohorte_bebe", replace
		
	keep 	if p_emb_obs_ave==1 

	egen 	tag_id_nacido = tag(id_nacido)
	gen 	mbpn          = peso_nacido<=2 
	gen     apgar1menor7  = apgar1min_7==0

	keep    if tag_id_nacido==1	

	gen 	unhealthy=1-(bpn==0&nacer_menos_37==0&apgar1menor7==0)

	replace numconsul4=1-numconsul4
	
	preserve
		keep codmundep codigo12
		gduplicates drop
		gen lhcs_munic = 1
		collapse (sum) lhcs_munic, by(codmundep)
		
		tempfile lhcs_munic
		save `lhcs_munic'
	restore
	
	merge m:1 codmundep using `lhcs_munic'
	
	global 	vars bpn nacer_menos_37 apgar1menor7 unhealthy numconsul4
	
	* Drop the singleton
	reghdfe unhealthy ave_prom_health if d_area_metro == 0, absorb(p_draw)
	replace tag_id_nacido = 0 if e(sample)==0 & d_area_metro == 0			//1 obs
	reghdfe unhealthy ave_prom_health if d_area_metro == 1, absorb(p_draw)
	replace tag_id_nacido = 0 if e(sample)==0 & d_area_metro == 1			//0 obs
	drop if tag_id_nacido == 0

	mean 	$vars
	keep 	if e(sample)==1

	global 	N: word count $vars
	mat 	table2 = J($N+1 , 4,.)


	local 	r=1
	foreach x of global vars {
        
		sum `x'
		mat table2[`r',1] = r(mean)
		mat table2[`r',2] = r(sd)
		
		sum `x' if d_area_metro==0
		mat table2[`r',3] = r(mean)
		mat table2[`r',4] = r(sd)
		
		local r = `r'+1
        
	}

	count 
	mat table2[$N+1, 1] = r(N)

	count if d_area_metro==0
	mat table2[$N+1, 3] = r(N)

	mat list table2

	putexcel set "Results\Tables paper matrices replication.xls", sheet("Raw Table 1") modify
	putexcel B2=mat(table2)
    
	
log close